// Tesina di Linguaggi e Traduttori
// Scanner di log del server apache
// Alberto Realis-Luc    Mat.142119
// Leandro Dipietro      Mat.134841

import java.io.*;

class LogAnalizer {
private static PrintWriter html;
private static int counter=0;
private static char checkIp=0, checkUtenteremoto=0, checkUtente=0, checkTempo=0, checkRichiesta=0, checkStatuscode=0,
					checkDimensione=0, checkRefer=0, checkUseragent=0;
private static Ip ip1, ip2;
private static String richiesta,utenteremoto,utente,refer,useragent;
private static DataOra tempo,tempo2,endTime;
private static int dimensione, dimensione2, statuscode, statuscode2;
private static boolean missingTime=false;
private static String ipExpReg,dataoraExpReg,bytesExpReg,statusExpReg;

public static void main(String argv[]) {
        if (argv.length==0) System.out.println("Uso: java LogAnalizer <inputfile.log> <queryfile>\n");
        else {
                System.out.println("LogAnalizer: analizzatore del log di Apache\n");
                if(argv.length>1) { //è stata richiesta una query
                        try {
                        	QueryScanner queryScanner=new QueryScanner(new java.io.FileReader(argv[1]));
                        	QueryParser queryParser = new QueryParser(queryScanner); //crea parser
                        	queryParser.parse(); //avvia parser
                        } 
                        catch (java.io.FileNotFoundException e) {
                            System.out.println("File non trovato: "+argv[1]+"\n");
                        }
                        catch (Exception e) {
                                System.out.println("Unexpected exception: "+e+"\n");
                                e.printStackTrace();
                        }
                }
                else { //non è stata richiesta una query
                        System.out.println("Query non inserita.");
                }
                try { //si prova a scrivere il file html in uscita
                        html=new PrintWriter(new BufferedWriter(new FileWriter("risultati.html")));
                        System.out.println("Inizio scrittura file HTML in uscita: risultati.html\n");
                        html.println("<HTML><HEAD>\n"); //Apre l'header html
                        html.println("<meta name=\"GENERATOR\" content=\"LogAnalizer\">\n");
                        html.println("<TITLE>LogAnalizer: Risultati");
                        html.println("</TITLE>\n");
                        html.println("</HEAD>\n");
                        html.println("<BODY bgcolor = #ffff00>\n"); //sfondo giallo stile report
                        try {
                        	html.println("<H2>"+argv[0]+"</H2>\n"); //nomelog.log in grande
                            for(int i=1;i<argv.length;i++) html.println("File della query: "+argv[i]);//si stampa la query
                            html.print("<br><br><table border=\"1\"><tr>\n"+ //si stampano le intestazioni...
                            		"<td><b>Indirizzo IP</b></td>\n"+ //... della tabella risultati
                            		"<td><b>Utente remoto</b></td>\n"+
                            		"<td><b>Utente</b></td>\n"+
                            		"<td><b>Data e Ora</b></td>\n"+
                            		"<td><b>Richiesta HTTP</b></td>\n"+
                            		"<td><b>Status</b></td>\n"+
                            		"<td><b>Bytes</b></td>\n"+
                            		"<td><b>Refer</b></td>\n"+
                            		"<td><b>Useragent</b></td></tr>\n");
                            System.out.println("Scansione file di log: "+argv[0]);
                            LogScanner logScanner=new LogScanner(new java.io.FileReader(argv[0])); //si passa allo scanner il file in$
                            System.out.println("Avvio del parser...\n");
                            LogParser logParser = new LogParser(logScanner); //crea parser
                            logParser.parse(); //avvia parser
                            html.print("</table><br><br>\nTrovati "+counter+" accessi corrispondenti.\n");
                            System.out.println("Trovati "+counter+" accessi corrspondenti.");
                    }
                    catch (java.io.FileNotFoundException e) {
                            System.out.println("File non trovato: "+argv[0]+"\n");
                    }
                    catch (java.io.IOException e) {
                            System.out.println("ERRORE IO nella scansione del file: "+argv[0]+"\n");
                            System.out.println(e);
                    }
                    catch (Exception e) {
                            System.out.println("Unexpected exception: "+e+"\n");
                            e.printStackTrace();
                    }
                    html.println("</BODY></HTML>"); //chiusura tag finali Html
                    html.flush();
                    html.close();
                    System.out.println("File risultati.html completato.\n");
            } //try fileWriter
            catch(IOException e){
                    System.out.println("Errore nella creazione del file html: "+e+"\n");
            }
    } //else argomenti non trovati
} //main

public static boolean checkAccess(Accesso accesso) {
	if(checkIp!=0) switch(checkIp) {
		case '=': if(!accesso.ip.isEqual(ip1)) return false; break;
		case '<': if(!accesso.ip.isSmaller(ip1) && !accesso.ip.isEqual(ip1)) return false; break;
		case '>': if(!accesso.ip.isGreater(ip1) && !accesso.ip.isEqual(ip1)) return false; break;
		case 4: if(!accesso.ip.isIn(ip1,ip2) && !accesso.ip.isEqual(ip1) && !accesso.ip.isEqual(ip2)) return false; break;
		case 5: if(!accesso.ip.toString().matches(ipExpReg)) return false; break;
	}	
	if(checkTempo!=0) switch(checkTempo) {
	case '=': if(missingTime) {
			if(!accesso.dataOra.isBetween(tempo,endTime)) return false;
		}
		else if(!accesso.dataOra.isEqual(tempo)) return false;
		break;
	case '<': if(!accesso.dataOra.isPast(tempo)) return false; break;
	case '>': if(!accesso.dataOra.isFuture(tempo)) return false; break;
	case 4: if(missingTime) tempo2=endTime;
		if(!accesso.dataOra.isBetween(tempo,tempo2)) return false;
		break;
	case 5: if(!accesso.dataOra.toString().matches(dataoraExpReg)) return false; break;
	}
	if(checkStatuscode!=0) switch(checkStatuscode) {
		case '=': if(accesso.status!=statuscode) return false; break;
		case '<': if(accesso.status>statuscode) return false; break;
		case '>': if(accesso.status<statuscode) return false; break;
		case 4: if(accesso.status<statuscode || accesso.status>statuscode2) return false; break;
		case 5: if(!(new Integer(accesso.status)).toString().matches(statusExpReg)) return false; break;
	}
	if(checkDimensione!=0) switch(checkDimensione) {
		case '=': if(accesso.bytes!=dimensione) return false; break;
		case '<': if(accesso.bytes>dimensione) return false; break;
		case '>': if(accesso.bytes<dimensione) return false; break;
		case 4: if(accesso.bytes<dimensione || accesso.bytes>dimensione2) return false; break;
		case 5: if(!(new Integer(accesso.bytes)).toString().matches(bytesExpReg)) return false; break;
	}	
	if(checkUtenteremoto=='=') {
		if(accesso.utenteRemoto.compareTo(utenteremoto)!=0) return false;
	}
	else if(checkUtenteremoto==':')
		if(!accesso.utenteRemoto.matches(utenteremoto)) return false;
	if(checkUtente=='=') {
		if(accesso.utente.compareTo(utente)!=0) return false;
	}
	else if(checkUtente==':')
		if(!accesso.utente.matches(utente)) return false;
	if(checkRichiesta=='=') {
		if(!accesso.richiesta.startsWith(richiesta)) return false;
	}
	else if(checkRichiesta==':')
		if(!accesso.richiesta.matches(richiesta)) return false;
	if(checkRefer=='=') {
		if(!accesso.refer.startsWith(refer)) return false;
	}
	else if(checkRefer==':')
		if(!accesso.refer.matches(refer)) return false;
	if(checkUseragent=='=') {
		if(!accesso.useragent.startsWith(useragent)) return false;
	}
	else if(checkUseragent==':')
		if(!accesso.useragent.matches(useragent)) return false;
	counter++;
	return true;
}

public static void setSingleIp(char rel, Ip ip) {
	if(checkIp==0) {
		ip1=ip;
		checkIp=rel;
	}
	else
		System.out.println("ATTENZIONE: condizione sull'ip già impostata, verrà verificata solo la prima rilevata.");
}

public static void setIpRange(Ip ipIniz, Ip ipFine)  {
	if(checkIp==0) {
		if(!ipIniz.isEqual(ipFine)) { //se non uguali
			checkIp=4; //segnala range di ip
			if(ipIniz.isSmaller(ipFine)) {
				LogAnalizer.ip1=ipIniz;
				LogAnalizer.ip2=ipFine;
			}
			else { //caso intervallo al contario
				LogAnalizer.ip1=ipFine;
				LogAnalizer.ip2=ipIniz;
			}
		}
		else setSingleIp('=',ipIniz);
	}
	else
		System.out.println("ATTENZIONE: condizione sull'ip già impostata, verrà verificata solo la prima rilevata.");
}

public static void setRichiesta(char rel,String ric) {
	if(checkRichiesta==0) {
		richiesta=ric;
		checkRichiesta=rel;
	}
	else
		System.out.println("ATTENZIONE: condizione sulla richiesta già impostata, verrà verificata solo la prima rilevata.");

}

public static void setUtenteRemoto(char rel, String ur) {
	if(checkUtenteremoto==0) {
		checkUtenteremoto=rel;
		utenteremoto=ur;
	}
	else
		System.out.println("ATTENZIONE: condizione sull'utente remoto già impostata, verrà verificata solo la prima rilevata.");
}

public static void setUtente(char rel, String ut) {
	if(checkUtente==0) {
		checkUtente=rel;
		utente=ut;
	}
	else
		System.out.println("ATTENZIONE: condizione sull'utente già impostata, verrà verificata solo la prima rilevata.");
}

public static void setRefer(char rel, String ref) {
	if(checkRefer==0) {
		checkRefer=rel;
		refer=ref;
	}
	else
		System.out.println("ATTENZIONE: condizione sul refer già impostata, verrà verificata solo la prima rilevata.");
}

public static void setUseragent(char rel, String ua) {
	if(checkUseragent==0) {
		checkUseragent=rel;
		useragent=ua;
	}
	else
		System.out.println("ATTENZIONE: condizione su useragent già impostata, verrà verificata solo la prima rilevata.");
}

public static void setSingleTime(char rel, DataOra dataora) {
	if(checkTempo==0 || checkTempo==6) {
		tempo=dataora;
		checkTempo=rel;
	}
	else
		System.out.println("ATTENZIONE: condizione sul tempo già impostata, verrà verificata solo la prima rilevata.");
}

public static void setTimeRange(DataOra dataoraIniz, DataOra dataoraFine) {
	if(checkTempo==0 || checkTempo==6) {
		if(!dataoraIniz.isEqual(dataoraFine)) { //date diverse
			checkTempo=4;
			if(dataoraIniz.isPast(dataoraFine)) {
				tempo=dataoraIniz;
				tempo2=dataoraFine;
			}
			else { //caso intervallo al contario
				tempo=dataoraFine;
				tempo2=dataoraIniz;
			}
		}
		else  setSingleTime('=',dataoraIniz);
	}
	else
		System.out.println("ATTENZIONE: condizione sul tempo già impostata, verrà verificata solo la prima rilevata.");
}

public static void setSingleStatus(char rel, int status) {
	if(checkStatuscode==0) {
		statuscode=status;
		checkStatuscode=rel;
	}
	else
		System.out.println("ATTENZIONE: condizione su statuscode già impostata, verrà verificata solo la prima rilevata.");
}

public static void setStatusRange(int status1, int status2) {
	if(checkStatuscode==0) {
		if(status1!=status2) { //statuscode diversi
			checkStatuscode=4;
			if(status1<status2) {
				statuscode=status1;
				statuscode2=status2;
			}
			else { //caso intervallo al contario
				statuscode=status2;
				statuscode2=status1;
			}
		}
		else setSingleStatus('=',status1);	
	}
	else
		System.out.println("ATTENZIONE: condizione su statuscode già impostata, verrà verificata solo la prima rilevata.");
}

public static void setSingleDimension(char rel, int dim) {
	if(checkDimensione==0) {
		dimensione=dim;
		checkDimensione=rel;
	}
	else
		System.out.println("ATTENZIONE: condizione sui bytes già impostata, verrà verificata solo la prima rilevata.");
}

public static void setDimensionRange(int dim1, int dim2) {
	if(checkDimensione==0) {
		if(dim1!=dim2) { //statuscode diversi
			checkDimensione=4;
			if(dim1<dim2) {
				dimensione=dim1;
				dimensione2=dim2;
			}
			else { //caso intervallo al contario
				dimensione=dim2;
				dimensione2=dim1;
			}
		}
		else setSingleDimension('=',dim1);
	}
	else
		System.out.println("ATTENZIONE: condizione sui bytes già impostata, verrà verificata solo la prima rilevata.");
}

public static void setEndTime(int gg, int mm, int aaaa, int ora, int min) {
	if(checkTempo==0) {   //caso di prima data
		endTime=new DataOra(gg,mm,aaaa,ora,min,59);
		checkTempo=6;
	}
	else { //seconda data di un intervallo
		DataOra tempEndTime=new DataOra(gg,mm,aaaa,ora,min,59);
		if(tempEndTime.isFuture(endTime)) endTime=tempEndTime; //caso patologico di intervallo invertito
	}
	LogAnalizer.missingTime=true;
}

public static void setEndTime(int gg, String mm, int aaaa, int ora, int min) {
	if(checkTempo==0) {   //caso di prima data
		endTime=new DataOra(gg,mm,aaaa,ora,min,59);
		checkTempo=6;
	}
	else { //seconda data di un intervallo
		DataOra tempEndTime=new DataOra(gg,mm,aaaa,ora,min,59);
		if(tempEndTime.isFuture(endTime)) endTime=tempEndTime; //caso patologico di intervallo invertito
	}
	LogAnalizer.missingTime=true;
}

public static void setIpExpReg(String expreg) {
	if(checkIp==0) {
		checkIp=5;
		ipExpReg=expreg;
	}
	else
		System.out.println("ATTENZIONE: condizione su ip già impostata, verrà verificata solo la prima rilevata.");
}

public static void setTimeExpReg(String expreg) {
	if(checkTempo==0 || checkTempo==6) {
		checkTempo=5;
		dataoraExpReg=expreg;
	}
	else
		System.out.println("ATTENZIONE: condizione sul tempo già impostata, verrà verificata solo la prima rilevata.");
}

public static void setStatusExpReg(String expreg) {
	if(checkStatuscode==0) {
		checkStatuscode=5;
		statusExpReg=expreg;
	}
	else
		System.out.println("ATTENZIONE: condizione su statuscode già impostata, verrà verificata solo la prima rilevata.");
}

public static void setBytesExpReg(String expreg) {
	if(checkDimensione==0) {
		checkDimensione=5;
		bytesExpReg=expreg;
	}
	else
		System.out.println("ATTENZIONE: condizione sui bytes già impostata, verrà verificata solo la prima rilevata.");
}

public static void printHtml(String text) {
	html.print(text);
}

} //class