// Tesina di Linguaggi e Traduttori
// Scanner di log del server apache
// Alberto Realis-Luc    Mat.142119
// Leandro Dipietro      Mat.134841

import java_cup.runtime.*;
%%
%state UTENTE
%state DATA
%state ORA
%state MIN
%state SEC
%state FUSO
%state RIC
%state STATUS
%state BYTES
%state REFER
%state USERAGENT

%class LogScanner
%integer //restituisce intero

%unicode

%cupsym LogSym
%eofval{
  return new java_cup.runtime.Symbol(LogSym.EOF);
%eofval}
%cup
acapo=\n|\r|\r\n
numip=[0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-5]
gg=[0-2][0-9]|3[0-1]
mm=Gen|Jan|Feb|Mar|Apr|Mag|May|Giu|Jun|Lug|Jul|Ago|Aug|Set|Sep|Ott|Oct|Nov|Dic|Dec
aaaa=19[5-9][0-9]|[2-9][0-9][0-9][0-9]
num24=[0-1][0-9]|2[0-3]
num60=[0-5][0-9]
fuso={num24}{num60}
statuscode=[0-9][0-9][0-9]
bytes=[0-9]+

%%
<YYINITIAL> { //riconosce le 4 cifre dell'indirizzo ip
	{numip} {return new Symbol(LogSym.NUMIP, new Integer(yytext()));}
	"." {;}
	[" "]+ {yybegin(UTENTE);}
	. {System.out.println("ERRORE: Carattere non riconosciuto nella sezione dell'indirizzo IP: "+yytext());}
}

<UTENTE> {
	[^" "\[\]]+ {return new Symbol(LogSym.STRINGA, new String(yytext()));}
	" " {;}
	"[" {yybegin(DATA);}
}

<DATA> {
	{gg} {return new Symbol(LogSym.GG, new Integer(yytext()));}
	"/" {;}
	{mm} {return new Symbol(LogSym.MM, new String(yytext()));}
	{aaaa} {return new Symbol(LogSym.AAAA, new Integer(yytext()));}
	":" {yybegin(ORA);}
	. {System.out.println("ERRORE: Carattere non riconosciuto nella sezione della data: "+yytext());}
}

<ORA> {
	{num24} {return new Symbol(LogSym.NUM24, new Integer(yytext()));}
	":" {yybegin(MIN);}
	. {System.out.println("ERRORE: Carattere non riconosciuto nella sezione dell'ora: "+yytext());}
}

<MIN> {
	{num60} {return new Symbol(LogSym.NUM60, new Integer(yytext()));}
	":" {yybegin(SEC);}
	. {System.out.println("ERRORE: Carattere non riconosciuto nella sezione dei minuti: "+yytext());}
}

<SEC> {
	{num60} {return new Symbol(LogSym.NUM60, new Integer(yytext()));}
	" " {yybegin(FUSO);}
	. {System.out.println("ERRORE: Carattere non riconosciuto nella sezione dei secondi: "+yytext());}
}

<FUSO> {
	"+" {;}
	{fuso} {return new Symbol(LogSym.FUSO, new Integer(yytext()));}
	"] \"" {yybegin(RIC);}
	. {System.out.println("ERRORE: Carattere non riconosciuto nella sezione del fuso orario: "+yytext());}
}

<RIC> {
	[^\"]* {return new Symbol(LogSym.STRINGA, new String(yytext()));}
	[\"][" "]* {yybegin(STATUS);}
}

<STATUS> {
	{statuscode} {return new Symbol(LogSym.STATUSCODE, new Integer(yytext()));}
	" " {yybegin(BYTES);}
	. {System.out.println("ERRORE: Carattere non riconosciuto nella sezione dello status code HTTP: "+yytext());}
}

<BYTES> {
	{bytes} {return new Symbol(LogSym.BYTES, new Integer(yytext()));}
	"-" {return new Symbol(LogSym.BYTES, new Integer(0));}
	[" "]*[\"] {yybegin(REFER);}
	. {System.out.println("ERRORE: Carattere non riconosciuto nella sezione dei bytes: "+yytext());}
}

<REFER> {
	[^\"]* {return new Symbol(LogSym.STRINGA, new String(yytext()));}
	[\"][" "]*[\"] {yybegin(USERAGENT);}
}

<USERAGENT> {
	[^\"]* {return new Symbol(LogSym.STRINGA, new String(yytext()));}
	[\"][" "]*{acapo} {yybegin(YYINITIAL);}
}
