// Tesina di Linguaggi e Traduttori
// Scanner di log del server apache
// Alberto Realis-Luc    Mat.142119
// Leandro Dipietro      Mat.134841

import java_cup.runtime.*;
%%
%state IP
%state GG
%state MMAAAA
%state ORA
%state MIN
%state SEC
%state STRINGA
%state EXPREG
%cupsym QuerySym
%eofval{
  return new java_cup.runtime.Symbol(QuerySym.EOF);
%eofval}
%cup
%class QueryScanner
%integer //restituisce intero

%unicode

numip=[0-9]|[1-9][0-9]|1[0-9][0-9]|2[0-4][0-9]|25[0-5]
gg=[0-9]|[0-2][0-9]|3[0-1]
mmtext=Gen|Jan|Feb|Mar|Apr|Mag|May|Giu|Jun|Lug|Jul|Ago|Aug|Set|Sep|Ott|Oct|Nov|Dic|Dec
mmnum=[1-9]|0[1-9]|1[0-2]
aaaa=19[5-9][0-9]|[2-9][0-9][0-9][0-9]
num24=[0-9]|[0-1][0-9]|2[0-3]
num60=[0-9]|[0-5][0-9]
relazione=[=<>:]
numero=[0-9]+

%%
<YYINITIAL> {
	"ip" {return new Symbol(QuerySym.IPKEYWORD);}
	"utenteremoto" {return new Symbol(QuerySym.UTENTEREMOTOKEYWORD);}
	"utente" {return new Symbol(QuerySym.UTENTEKEYWORD);}
	"tempo" {return new Symbol(QuerySym.TEMPOKEYWORD);}
	"richiesta" {return new Symbol(QuerySym.RICHIESTAKEYWORD);}
	"status" {return new Symbol(QuerySym.STATUSCODEKEYWORD);}
	"bytes" {return new Symbol(QuerySym.DIMENSIONEKEYWORD);}
	"refer" {return new Symbol(QuerySym.REFERKEYWORD);}
	"useragent" {return new Symbol(QuerySym.USERAGENTKEYWORD);}
	{relazione} {return new Symbol(QuerySym.RELAZIONE, new String(yytext()));}
	{numero} {return new Symbol(QuerySym.NUMERO, new Integer(yytext()));}
	"-" {return new Symbol(QuerySym.MENO);}
	"(" {yybegin(IP);}
	"[" {yybegin(GG);}
	"'" {yybegin(STRINGA);}
	\n|\r|\n\r|\t|" " {;}
	. {System.out.println("ERRORE: Carattere non riconosciuto: "+yytext());}
}

<IP> {
	{numip} {return new Symbol(QuerySym.NUMIP, new Integer(yytext()));}
	"." {return new Symbol(QuerySym.PUNTO);}
	"-" {return new Symbol(QuerySym.MENO);}
	")" {yybegin(YYINITIAL);}
}

<GG> {
	{gg} {return new Symbol(QuerySym.GG, new Integer(yytext()));}
	"/" {yybegin(MMAAAA);}
	. {System.out.println("ERRORE: Carattere non riconosciuto nella sezione del giorno: "+yytext());}
}

<MMAAAA> {
	{mmtext} {return new Symbol(QuerySym.MMTEXT, new String(yytext()));}
	{mmnum} {return new Symbol(QuerySym.MMNUM, new Integer(yytext()));}
	"/" {;}
	{aaaa} {return new Symbol(QuerySym.AAAA, new Integer(yytext()));}
	":" {yybegin(ORA);}
	"-" {yybegin(GG);}
	"]" {yybegin(YYINITIAL);}
	. {System.out.println("ERRORE: Carattere non riconosciuto nella sezione del mese o dell'anno: "+yytext());}
}

<ORA> {
	{num24} {return new Symbol(QuerySym.NUM24, new Integer(yytext()));}
	":" {yybegin(MIN);}
	"-" {yybegin(GG);}
	"]" {yybegin(YYINITIAL);}
	. {System.out.println("ERRORE: Carattere non riconosciuto nella sezione dell'ora: "+yytext());}
}

<MIN> {
	{num60} {return new Symbol(QuerySym.NUM60, new Integer(yytext()));}
	":" {yybegin(SEC);}
	"-" {yybegin(GG);}
	"]" {yybegin(YYINITIAL);}
	. {System.out.println("ERRORE: Carattere non riconosciuto nella sezione dei minuti: "+yytext());}
}

<SEC> {
	{num60} {return new Symbol(QuerySym.NUM60, new Integer(yytext()));}
	"-" {yybegin(GG);}
	"]" {yybegin(YYINITIAL);}
	. {System.out.println("ERRORE: Carattere non riconosciuto nella sezione dei secondi: "+yytext());}
}

<STRINGA> {
	[^']* {return new Symbol(QuerySym.STRINGA, new String(yytext()));}
	['] {yybegin(YYINITIAL);}
}